// C Source File
// Created 2/27/2004; 11:01:46 PM

// Delete or comment out the items you do not need.



#include <tigcclib.h>
#include "extgraph.h"
#include "h.h"
#include "pic.h"


#define num_of_coord_arrays (40)
#define level_width (14)	//must be an even number
#define level_height (22) //must be an even number
#define PI (3.141592653589793)
#define linex (5.02)
#define liney (8.02)
#define lineoffset (2)
#define key_delay (5)
#define QUICK_DELAY (9)
#define next_piece_rect_x (122)
#define next_piece_rect_y (20)
#define next_piece_rect_side (22)


typedef struct {
char type;
char posit;
char newposit;//temporaly used
int x;
int y;
char new;
int newx;//temporaly used
int newy;//temporaly used
char delay;
} BLOCK;




typedef struct {
char how_long_till_quick_repeat;
char key_press_delay;
int score;
} PLAYA;


BLOCK piece,nextpiece;

PLAYA player;
char level[level_height][level_width];

void *buffer,*buffer2;
LCD_BUFFER saved_screen;

short* pcos;
short *psin;
short score;




void init_array() {
	int i,j;
	for (i=0;i < level_width; i++) {
		for (j=0; j < level_height; j++) {		
			level[j][i] = (j==level_height-1) | (i==0) | (i==level_width-1);
		}
	}
}



static inline void draw_element(int x, int y) {
//Sprite8_OR(dat.x[n][x][y],dat.y[n][x][y], 4, sprite, buffer);
Sprite8_OR(x,y, 4, sprite, buffer);
}



void draw_in_buffer2() {
	PortSet (buffer2, 239, 127);
	ClrScr();
	DrawLine(110,0,110,LCD_HEIGHT-1,A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(120,2,"XTetris",A_NORMAL);
	DrawStr(120,80,"::Score::",A_NORMAL);
	DrawClipRect(
	&(WIN_RECT){next_piece_rect_x,next_piece_rect_y,next_piece_rect_x+next_piece_rect_side,next_piece_rect_y+next_piece_rect_side},
	&(SCR_RECT){{0,0,LCD_WIDTH-1,LCD_HEIGHT-1}},A_NORMAL);
	PortSet (LCD_MEM, 239, 127);
	int i;
	char r[10];
	sprintf(r,"%d",score);

	for (i=6;i--;) { //"only" scores up tp 999999 will be correctly shown
 		if (r[i] >47 && r[i] < 58)
 		Tile8x8_OR_R(i+14,90,number_sprite[r[i]-48],buffer2);
	}	
}








void draw_next_piece_in_rect() {
draw_in_buffer2();
	int i,j;
	for (i=4;i -- ; ) {
		for (j=4; j --; ) {
			if (tableau[nextpiece.type*4+nextpiece.posit][((3-j)+4*i)]==1)
				Sprite8_OR(j*5+next_piece_rect_x+1,i*5+next_piece_rect_y+2, 4, sprite, buffer2);
		}
	}
}







void put_piece_in_array(short n) {
	int i,j;
	for (i=0;i<4;i++) {
		for (j=0;j<4;j++) {
			if (tableau[piece.type*4+piece.posit][j+4*i]==1)
				level[j+piece.y][i+piece.x]=n;
		}
	}
}



short s_l[] = {0,5060,150,400,900};
void check_if_rows_have_been_made() {
	int x,y,n,p=0;
	for (y=0;y<level_height-1;y++) {
		n=0;
		for (x=0;x<level_width;x++) {
			n+=level[y][x];
		}
		if (n==level_width) {
			p++;
			memmove(&level[1][0],&level[0][0],(y)*level_width);
			y=0;
		}
	}
	score +=s_l[p];
}



char test_piece_collision() {
	int i,j;
	for (i=0;i<4;i++) {
		for (j=0;j<4;j++) {//j:balaye horizontalement
			if (tableau[piece.type*4+piece.newposit][j+4*i]==1 && level[j+piece.newy][i+piece.newx]==1)
				return(1);
		}
	}
	return(0);
}



void copy_screen() {
 	FastCopyScreen(buffer,LCD_MEM);
}



void new_piece() {
	piece.x = 5;
	piece.y = 0;
	piece.posit = 0;
	piece.type = nextpiece.type;
	nextpiece.type = random(7);
	draw_next_piece_in_rect();
}




void move_according_the_keyboard() {
	
	if (player.key_press_delay < key_delay && player.how_long_till_quick_repeat==QUICK_DELAY)
		player.key_press_delay ++;
	
	
	if (!_keytest(RR_UP) && !_keytest(RR_DOWN) && !_keytest(RR_LEFT) && !_keytest(RR_RIGHT)) {
		player.key_press_delay = key_delay;
		player.how_long_till_quick_repeat = 0;
	}
	else
	{
		player.how_long_till_quick_repeat+=player.how_long_till_quick_repeat<QUICK_DELAY;
	}
	
	
	if (player.key_press_delay == key_delay) {
	
		if (_keytest(RR_UP)) {
			player.key_press_delay=0;
			piece.newposit ++;
			if (piece.newposit == 4)
				piece.newposit = 0;
				if (test_piece_collision()==0) {
					piece.posit = piece.newposit;
				}
		}
		
	/*	if (_keytest(RR_DOWN)) {
			piece.delay = 10;
			put_piece_in_array(0);
			while (!test_piece_collision()) {piece.newy++;};
		}*/
		
		if (_keytest(RR_DOWN)) {
			piece.delay = 20;
		}
		
		
		if (_keytest(RR_LEFT)/*&& piece.x != 0*/) {
			piece.newx--;
			player.key_press_delay=0;
		}
		
		if (_keytest(RR_RIGHT) ) {
			piece.newx++;
			player.key_press_delay=0;
		}
		
	}
	
	
	if (test_piece_collision()==0) {
		piece.x = piece.newx;
	}

}





void move_down() {

	if (piece.delay == 20) {
		piece.newy++;
		piece.delay=0;
		if (test_piece_collision()==1) {
			put_piece_in_array(1);
			check_if_rows_have_been_made();
			new_piece();
		}
		else
		{
		piece.y=piece.newy;
		}
	}
	
}




void put_old_in_new() {
	piece.newy=			piece.y;
	piece.newx=			piece.x;
	piece.newposit=	piece.posit;
}




void move_piece() {
	piece.delay++;
	put_old_in_new();
	move_according_the_keyboard();
	put_old_in_new();
	move_down();
}




	
	
void explose_dots(short ii) {
	short cx,cy;
	short i;
	short j;
	short fx[level_width][level_height];
	short fy[level_width][level_height];
	short vx[level_width][level_height];
	short vy[level_width][level_height];
	
	
	//memcpy(LCD_MEM,buffer2,LCD_SIZE);
	for(i=31;i--;)
	memcpy(buffer2+30*20+30*i+1,lost+10*i,10);
	FontSetSys(F_4x6);
	
	PortSet(buffer2,240-1,128-1);
	DrawStr(20,60,"-Press enter loser-",A_NORMAL);
	PortSet(LCD_MEM,LCD_WIDTH-1,LCD_HEIGHT-1);
	//memcpy(buffer2,LCD_MEM,LCD_SIZE);
	
	for (j=0;j<level_width;j++) {
		cx=(54)+((psin[ii]*(j-6))>>6);
		cy=(48)-((pcos[ii]*(j-6))>>6);
		for (i=0;i<level_height;i++) {
					fx[j][i] = ((cx)+((pcos[ii]*(i-10))>>6))<<5;
					fy[j][i] = ((cy)+((psin[ii]*(i-10))>>6))<<5;		
			
			vx[j][i] = random(10)-5;
			vy[j][i] = random(4)-2;
		}
	}
		

	while (!_keytest(RR_ENTER)) {

	
	FastCopyScreen(buffer2,buffer);
	for (j=0;j<level_width;j++) {
		for (i=1;i<level_height;i++) {
			fx[j][i] += vx[j][i];
			fy[j][i] += vy[j][i];
			vy[j][i]+=6;
			if ((fy[j][i]>>5) > 100) {
				fy[j][i] = 100<<5;
				fy[j][i] -=vy[j][i];
				vy[j][i] =-vy[j][i]/2;
			}
			if (level[i][j] != 0)
			ClipSprite8_OR_R(fx[j][i]>>5,fy[j][i]>>5,4,sprite,buffer);

		}
	}
	FastCopyScreen(buffer,LCD_MEM);
	}
	
	//for(i=31;i--;)
	//memset(buffer2+30*20+30*i+1,0,10);
	
	
}





void play() {

	nextpiece.posit = 0;
	nextpiece.type = 0;
	
	
	
	short fx[level_width][level_height];
	short fy[level_width][level_height];
	short i;
	short ii=0,n=0;
	short j;	

	
	short cx[level_width],cy[level_width],cx2[level_height],cy2[level_height];	
	
	init_array();
	new_piece();
	

	n=3;
	while (!_keytest(RR_ESC)) {

		n++;
		if (n>100)
		n-=80;


		move_piece();
		put_piece_in_array(1);
		
		if (n%4==0) {
			ii++;
			if (ii==99)
			ii=1;
			//ii=25;
			short iii=ii;
			short nn=0;
			
			for (j=0;j<level_width;j++) {
				cx[j]=(54)+((psin[ii]*(j-6))>>6);
				cy[j]=(48)-((pcos[ii]*(j-6))>>6);				
			}
			for (j=0;j<level_height;j++) {
				iii+=(nn%3)==0;
				nn++;
				if (iii==99)
				iii=1;	
				
				cx2[j]=((pcos[iii]*(j-10))>>6);
				cy2[j]=((psin[iii]*(j-10))>>6);

				
			}
			
			
			for (j=0;j<level_width;j++) {
				//cx=(54)+((psin[ii]*(j-6))>>6);
				//cy=(48)-((pcos[ii]*(j-6))>>6);
				for (i=0;i<level_height;i++) {
					//fx[j][i] = (cx)+((pcos[ii]*(i-10))>>6);
					//fy[j][i] = (cy)+((psin[ii]*(i-10))>>6);	
					
					fx[j][i] = cx[j]+cx2[i];
					fy[j][i] = cy[j]+cy2[i];
					
					
				}
			}
		}
		
		
			
		FastCopyScreen(buffer2,buffer);
		
		
		for (j=0;j<level_width;j++) {
			for (i=1;i<level_height;i++) {
				if (level[i][j] != 0)
				Sprite8_OR_R(fx[j][i],fy[j][i],4,sprite,buffer);
			}
		}	
		
		if (_keytest(RR_F1)) {
			explose_dots(ii);
		}
		
			
		copy_screen();
		put_piece_in_array(0);


	}
}

static char* menu_str[]={(char*)&"1. Play",(char*)&"2. Score",(char*)&"3. Quit"};
short menu(short * r) {
	ClrScr();
	FontSetSys(F_4x6);
	short i;
	for (i=20;i--;) {
	memcpy(LCD_MEM+30*10+((LCD_WIDTH-144)/16)+30*i,title+(144/8)*i,144/8);	
	if (i<3)
	DrawStr(20,50+i*8,menu_str[i],A_NORMAL);
	}
	while (!i)
	i=_keytest(RR_1)*4+_keytest(RR_2)*2+_keytest(RR_3);		
	
	*r = i;
	return(!(i&1));
}



	
void _main(void)
	{

	//
	buffer = malloc (LCD_SIZE*2+100*4);
	if (!buffer)
	exit(0);
	score = 0;
	pcos = (short*)(buffer+LCD_SIZE*2+level_width*level_height*2*2);
	psin = pcos+100;

	OSSetSR (0x0700);	
	short i=0;
	float time=0;

	float a;
	for (time = 0; time < PI/2; time+=PI*2/99) {	

	a = fmul(cos(time),1)+PI/2;
		
		pcos[i] = fmul(cos(a),256);
		psin[i] = fmul(sin(a),256);
		
		pcos[49-i] = -pcos[i];
		psin[49-i] = psin[i];
		
		pcos[49+i] = pcos[49-i];
		psin[49+i] = psin[49-i];

		pcos[98-i] = pcos[i];
		psin[98-i] = psin[i];		
			
		
		i++;
	//sprintf(str,"%i/100",i<<2);
	//	ST_helpMsg(str);
	}
	

	
	buffer2 = buffer+LCD_SIZE;
	
	draw_in_buffer2();
	short result;
	while (menu(&result)) {
		
		
		if (result == 4) {
			
			play();
		}
		
	}
	free(buffer);
	
	OSSetSR (0x0000);
}
